#include  <stdio.h>
#include  <stdlib.h>
#include  <string.h>

#include  "pokesound.h"

/* ----------------------------------------------------------------- */
int proto_fade_in ( SndPk_sndbuff *buff, float duration)
{
int		nbs, idx;
float		coef;
short		*sptr, smp;

fprintf(stderr, ">>> %s ( %p %f )\n", __func__, buff, duration);

nbs = (int)(buff->samplerate * duration);
fprintf(stderr, "    %.3f s -> %d smpls\n", duration, nbs);
// fprintf(stderr, "    buff: %ld frames\n", buff->nbframes);

sptr = (short *)buff->datas;
for (idx=0; idx<nbs; idx++) {
	coef = (float)idx / (float)nbs;
	// fprintf(stderr, "%9d  %f\r", idx, coef);
	smp = *sptr;
	*sptr++ = (short)( (float)smp * coef );
	smp = *sptr;
	*sptr++ = (short)( (float)smp * coef );
	}

return 0;
}
/* ----------------------------------------------------------------- */
int proto_fade_out (SndPk_sndbuff *buff, float duration)
{
int		nbs, idx;
short		*sptr, smp;
float		coef;

fprintf(stderr, ">>> %s ( %p %f )\n", __func__, buff, duration);

nbs = (int)(buff->samplerate * duration);
fprintf(stderr, "    %.3f s -> %d smpls\n", duration, nbs);
// fprintf(stderr, "    %ld frames\n", buff->nbframes);

sptr = ((short *)buff->datas) + (buff->nbframes - (2*nbs));

for (idx=0; idx<nbs; idx++) {
	coef = 1.0 - ((float)idx / (float)nbs);

	smp = *sptr;
	*sptr++ = (short)( (float)smp * coef );
	smp = *sptr;
	*sptr++ = (short)( (float)smp * coef );

	}

return 0;
}

/* ----------------------------------------------------------------- */

